//*******************************************************************************
// Clear the seven segment display on the multi-function board
//*******************************************************************************/

int latchPin = 4;
int clockPin = 7;
int dataPin  = 8; // pins connected to the shift registers
int LED1 =13;
int LED2 =12;
int LED3 =11;
int LED4 =10;

unsigned char clearCode = 0xff;
//          0
//       -------
//      |       |
//    5 |       | 1
//      |   6   |
//       -------
//      |       |
//    4 |       | 2
//      |   3   |
//       -------
//                  * 7
//
unsigned char Dis_buf[]   = {0xF1,0xF2,0xF4,0xF8};
unsigned char cnt = 0;
unsigned char digit[4];


void setup ()
{
  
  pinMode(latchPin,OUTPUT);
  pinMode(clockPin,OUTPUT);
  pinMode(dataPin,OUTPUT);                                       // set the 7-segment control pins to output
  for(int i=0; i<=3; i++)                                        // loop over the 4 digits
  {
    digitalWrite(latchPin,LOW);                                  // don't latch
    shiftOut(dataPin,clockPin,MSBFIRST,clearCode);               // address the digt
    shiftOut(dataPin,clockPin,MSBFIRST,Dis_buf[i] );             // the LED code for the digit
    digitalWrite(latchPin,HIGH);                                 // latch the data   
    delay(2); 
  }
}

void loop()
{   

}
