/*
 * program to test the scilib serial interface 
 * copyright U. Raich Jan. 2019
 * The program is released under the GNU Public License
 */

#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#include "arduino_serial.h"

int main(void) {
  int handle=-1;
  int errCode=-1;
  int port=0;
  int baudrate=115200;
  char *on ="Dw=1";
  char *off="Dw=0";
  char *version="V";
  char *attach="Da=1";
  char buf[10];
  int noOfCharsToRead=3;
  int versionSize = strlen(version);
  int onOffSize = strlen(on);
  int attachSize = strlen(attach);
  int i;
  
  printf("Testing the Arduino SciLab server using serialLib\n");
    
  open_serial(&handle, &port, &baudrate,&errCode);
  if (errCode != ARDUINO_SUCCESS)
    printf("Could not open the serial port /dev/ttyUSB%d\n",port);
  else
    printf("/dev/ttyUSB%d was successfully opened\n",port);
  write_serial(&handle,version,&versionSize,&errCode);
  if (errCode != ARDUINO_SUCCESS)
    printf("Could not write cmd to Arduino\n");
  
  read_serial(&handle,buf,&noOfCharsToRead,&errCode);
  if (errCode != ARDUINO_SUCCESS)
    printf("Could not read from Arduino\n");
  else {
    if (buf[0] != 'V') {
      printf("Could not read server version number\n");
      close_serial(&handle,&errCode);
    }
    printf("Version: %c.%c\n",buf[1],buf[2]);
  }
  /*
   * set GPIO 13 to output
   */
  write_serial(&handle,attach,&attachSize,&errCode);
  for (i=0;i<5;i++) {
    write_serial(&handle,on,&onOffSize,&errCode);
    usleep(500000);
    write_serial(&handle,off,&onOffSize,&errCode);
    usleep(500000);
  }
  close_serial(&handle,&errCode);
  return 0;
}
