#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>

#define BAUDRATE B115200

int main(void) {
    fd_set rfds;
    struct timeval tv;
    struct termios newtio;
    int retval;
    int i,fd;
    char buf[100];
    //    char dummy = '\n';
    char *version="V";
    char *attach="Da=1";
    char *on ="Dw=1";
    char *off="Dw=0";

    printf("Testing the Arduino SciLab server\n");
    
    //    fd = open("/dev/ttyUSB0",O_RDWR );
    
    fd = open("/dev/ttyUSB0",O_RDWR | O_NOCTTY );
    if (fd <0) {
      printf("Could not open /dev/ttyUSB0\n");
      return -1;
    }
    else
      printf("/dev/ttyUSB0 successully opened\n");
    sleep(2);
    bzero(&newtio, sizeof(newtio));
    newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
    newtio.c_iflag = IGNPAR;
    newtio.c_oflag = 0;
   /* set input mode (non-canonical, no echo,...) */
    newtio.c_lflag = 0;
   
    newtio.c_cc[VTIME]    = 0;   /* inter-character timer unused */
    newtio.c_cc[VMIN]     = 2;   /* blocking read until 5 chars received */
  
    tcflush(fd, TCIFLUSH);
    //    tcsetattr(fd,TCSANOW,&newtio);
    tcsetattr(fd,TCSAFLUSH,&newtio);

    //    write(fd,&dummy,1);
    /*
      get the current version of the Arduino server
    */
    printf("Asking for the server version number: %s\n",version);
    write(fd,version,(int)strlen(version));    
    /* Watch stdin (fd 0) to see when it has input. */
    FD_ZERO(&rfds);
    FD_SET(fd, &rfds);
    /* Wait up to five seconds. */
    tv.tv_sec = 5;
    tv.tv_usec = 0;
    retval = select(fd+1, &rfds, NULL, NULL, &tv);
    /* Don’t rely on the value of tv now! */

    if (retval == -1)
        perror("select()");
    else if (retval) {
        printf("Data is available now.\n");
	read(fd,buf,3);
	if (buf[0] == 'V')
	  printf("Server version: %c.%c\n",buf[1],buf[2]);
	else
	  printf("Unknown server version\n");
    }
    /* FD_ISSET(0, &rfds) will be true. */
    else {
        printf("Timeout: No data within five seconds.\n");
	close(fd);
	return -1;
    }

    /*
      declare pin 13 GPIO output
    */
    write(fd,attach,(int)strlen(attach));

    for (i=0;i<5;i++) {
      write(fd,on,(int)strlen(on));
      usleep(500000);
      write(fd,off,(int)strlen(off));
      usleep(500000);
      
    }
   close(fd);
    return 0;
}
