/*
 * program to test the scilib serial interface 
 * copyright U. Raich Jan. 2019
 * The program is released under the GNU Public License
 */

#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <stdbool.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#include "arduino_serial.h"

int main(void) {
  int i,handle=-1;
  int errCode=-1;
  int port=0;
  int baudrate=115200;
  char *version="V";
  char writeLED[5];
  int writeLEDSize;
  char buf[10];
  int noOfVersionCharsToRead=3;
  int versionSize = strlen(version);
  
  printf("Testing the Arduino SciLab server using serialLib\n");
  printf("Test switch reading\n");   
  open_serial(&handle, &port, &baudrate,&errCode);
  if (errCode != ARDUINO_SUCCESS)
    printf("Could not open the serial port /dev/ttyUSB%d\n",port);
  else
    printf("/dev/ttyUSB%d was successfully opened\n",port);
  write_serial(&handle,version,&versionSize,&errCode);
  if (errCode != ARDUINO_SUCCESS)
    printf("Could not write cmd to Arduino\n");
  
  read_serial(&handle,buf,&noOfVersionCharsToRead,&errCode);
  if (errCode != ARDUINO_SUCCESS)
    printf("Could not read from Arduino\n");
  else {
    if (buf[0] != 'V') {
      printf("Could not read server version number\n");
      close_serial(&handle,&errCode);
    }
    printf("Version: %c.%c\n",buf[1],buf[2]);
  }
  
  sprintf(writeLED,"P:%02x",0);
  writeLEDSize=strlen(writeLED);
  printf("writeLEDSize: %d string: %s\n",writeLEDSize,writeLED);
  writeLED[5]='\0';
  for (i=0;i<256;i++) {
    sprintf(writeLED,"P:%02x",255-i);
    printf("Written: %s\n",writeLED);
    write_serial(&handle,writeLED,&writeLEDSize,&errCode);
    usleep(50000);
  }
  for (i=0;i<256;i++) {
    sprintf(writeLED,"P:%02x",i);
    printf("Written: %s\n",writeLED);
    write_serial(&handle,writeLED,&writeLEDSize,&errCode);
    usleep(50000);
  }

  close_serial(&handle,&errCode);
  return 0;
}
