/* ==================================================================== */
/* Template toolbox_skeleton */
/* This file is released under the 3-clause BSD license. See COPYING-BSD. */
/* ==================================================================== */
#ifndef __ARDUINO_SERIAL_H__
#define __ARDUINO_SERIAL_H__

#define ARDUINO_SUCCESS              0
#define ARDUINO_BAD_OPEN            -1
#define ARDUINO_ILLEGAL_BAUDRATE    -2
#define ARDUINO_ILLEGAL_PORT        -3
#define ARDUINO_WRITE_ERROR         -4
#define ARDUINO_READ_ERROR          -5
#define ARDUINO_READ_TIMEOUT        -6
/**
* open_serial function
* @param[out] file descriptor
* @param[in] port number (0..3)
* @param[in] baud rate
* @param[out] error code
*/
void open_serial(int *handle, int *port, int *baudrate, int *errCode);
/**
* close_serial function
* @param[in] file descriptor
* @param[out] error code
*/
void close_serial(int *handle, int *errCode);
void write_serial(int *handle, char *str, int *size, int *errCode);
void read_serial(int *handle,char *buf, int *size, int *errCode);
void status_serial(int *handle,char *errCode, int *nbread, int *nbwrite);

#endif /* __ARDUINO_SERIAL_H__ */

