/*
  Rotary Encoder test
  Copyright (c) U. Raich 2019 for the University of Cape Coast, Ghana (UCC)
*/

#include "PinChangeInterrupt.h"
#include <SendOnlySoftwareSerial.h>

// Choose a valid PinChangeInterrupt pin of your Arduino board

#define CLK_PIN    4
#define DT_PIN 5
#define RX_PIN 11
#define TX_PIN 10

int counter=0;
SendOnlySoftwareSerial serial1 = SendOnlySoftwareSerial(TX_PIN);

void setup() {
  Serial.begin(115200);
  serial1.begin(115200);
  serial1.println("Encoder test ready!"); 
  // set pin to input with a pullup, led to output
  pinMode(CLK_PIN, INPUT_PULLUP);
  pinMode(DT_PIN, INPUT_PULLUP);
  
  // Attach the new PinChangeInterrupt and enable event function below
  attachPCINT(digitalPinToPCINT(CLK_PIN), rotaryCount, CHANGE);
}

void rotaryCount(void) {
  int clk,dt;
  clk=digitalRead(CLK_PIN);
  dt =digitalRead(DT_PIN);

  if (clk == dt)
    counter--;
  else
    counter ++;
  serial1.print("Counter: ");
  serial1.println(counter);
}

void loop() {
  // Nothing to do here
}
