/*
 * program to test the scilib serial interface 
 * copyright U. Raich Jan. 2019
 * The program is released under the GNU Public License
 */

#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <stdbool.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#include "arduino_serial.h"

#define A1 15

int main(void) {
  int  handle=-1;
  int  errCode=-1;
  int  port=0;
  int  baudrate=115200;
  char *version="V";
  char attach[6];
  int  attachSize;
  char detach[4];
  int  detachSize;
  char buf[10];
  char upDown='u';
  int  noOfVersionCharsToRead=3;
  int  versionSize = strlen(version);
  
  printf("Testing the Arduino SciLab server using serialLib\n");
  printf("Test switch reading\n");   
  open_serial(&handle, &port, &baudrate,&errCode);
  if (errCode != ARDUINO_SUCCESS)
    printf("Could not open the serial port /dev/ttyUSB%d\n",port);
  else
    printf("/dev/ttyUSB%d was successfully opened\n",port);
  write_serial(&handle,version,&versionSize,&errCode);
  if (errCode != ARDUINO_SUCCESS)
    printf("Could not write cmd to Arduino\n");
  
  read_serial(&handle,buf,&noOfVersionCharsToRead,&errCode);
  if (errCode != ARDUINO_SUCCESS)
    printf("Could not read from Arduino\n");
  else {
    if (buf[0] != 'V') {
      printf("Could not read server version number\n");
      close_serial(&handle,&errCode);
    }
    printf("Version: %c.%c\n",buf[1],buf[2]);
  }

  sprintf(attach,"Ia%c%c%c",'f',upDown,'0'+A1);
  attachSize = strlen(attach);
  write_serial(&handle,attach,&attachSize,&errCode);
  printf("Sending: message %s of size %d\n",attach,attachSize);
  usleep(500000);
  sprintf(detach,"Id%c",'0'+A1);
  detachSize= strlen(detach);
  write_serial(&handle,detach,&detachSize,&errCode);
  printf("Sending: message %s of size %d\n",detach,detachSize);
  usleep(500000);  
  close_serial(&handle,&errCode);
  return 0;
}
