/*
 * program to test the scilib serial interface 
 * copyright U. Raich Jan. 2019
 * The program is released under the GNU Public License
 */

#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#include "arduino_serial.h"

int main(void) {
  int handle=-1;
  int errCode=-1;
  int port=0;
  int baudrate=115200;
  char *on ="7o";
  char *off="7c";
  char *writeCmd="7f";
  char *version="V";
  char *firstVal="1234.";
  char *secondVal="-90.1";
  char valueCmd[8];
  int  writeCmdSize;
  char buf[10];
  int noOfCharsToRead=3;
  int versionSize = strlen(version);
  int onOffSize = strlen(on);
  
  printf("Testing the Arduino SciLab server using serialLib\n");
  printf("Test for seven segment display\n");
  
  open_serial(&handle, &port, &baudrate,&errCode);
  if (errCode != ARDUINO_SUCCESS)
    printf("Could not open the serial port /dev/ttyUSB%d\n",port);
  else
    printf("/dev/ttyUSB%d was successfully opened\n",port);
  write_serial(&handle,version,&versionSize,&errCode);
  if (errCode != ARDUINO_SUCCESS)
    printf("Could not write cmd to Arduino\n");
  
  read_serial(&handle,buf,&noOfCharsToRead,&errCode);
  if (errCode != ARDUINO_SUCCESS)
    printf("Could not read from Arduino\n");
  else {
    if (buf[0] != 'V') {
      printf("Could not read server version number\n");
      close_serial(&handle,&errCode);
    }
    printf("Version: %c.%c\n",buf[1],buf[2]);
  }
  /*
   * switch display on
   */
  write_serial(&handle,on,&onOffSize,&errCode);
  usleep(50000);
  strcpy(valueCmd,writeCmd);
  strcat(valueCmd,firstVal);
  writeCmdSize=strlen(valueCmd);
  write_serial(&handle,valueCmd,&writeCmdSize,&errCode);
  sleep(5);

  strcpy(valueCmd,writeCmd);
  strcat(valueCmd,secondVal);
  writeCmdSize=strlen(valueCmd);
  write_serial(&handle,valueCmd,&writeCmdSize,&errCode);
  sleep(5);
  write_serial(&handle,off,&onOffSize,&errCode);

  close_serial(&handle,&errCode);
  return 0;
}
