//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//

function [x, y, typ]=ARDUINO_ENCODER(job, arg1, arg2)
    x=[];
    y=[];
    typ=[];
    select job
    case 'plot' then
        // deprecated
    case 'getinputs' then
        // deprecated
    case 'getoutputs' then
        // deprecated
    case 'getorigin' then
        // deprecated
    case 'set' then
        x=arg1;
        graphics=arg1.graphics;
        exprs=graphics.exprs
        model=arg1.model;
        
        while %t do
            [ok,num_pin,num_arduino,exprs]=scicos_getvalue(..
                ['Arduino Encoder parameters'],..
            [gettext('Clk Pin, Data Pin'), ..
             gettext('Arduino board number')], list('vec',2,'vec',1), exprs(1:2))
            mess=[];
            if ~ok then break; end //cancel
            //security tests
            disp(exprs)
            if num_arduino<>1 then
                mess=[mess ;gettext("Only card 1 can be used with this toolbox version ")];
                ok=%f;
            end
            //          if num_encoder < 1 | num_encoder>4
            //              mess=[mess ;_("Encoder number must be 1 or 2 ")]
            //              ok = %f
            //          end

            if ok then// Everything's ok
                model.rpar=[num_pin,num_arduino];
                graphics.exprs = exprs;
                x.model=model;
                x.graphics = graphics;
                break
            else
                message(mess);
            end     
 
        end
    case 'define' then
        model=scicos_model();
        model.sim=list("ARDUINO_ENCODER_sim", 5)
        model.blocktype='d';
        model.dep_ut=[%f %f];
        model.out=[1];
        model.evtin=[1];
        model.evtout=[1];
        model.firing=[0;-1]
        //num_encoder=1;
        num_arduino=1;Pin=[4,5];
        model.rpar=[Pin,num_arduino]; //Default Pin number and Arduino card number
        x=standard_define([2 2],model,[],[]);
        x.graphics.out_implicit=['E'];
        x.graphics.style=["blockWithLabel;verticalLabelPosition=bottom;"+...
                          "verticalAlign=top;spacing=-2;displayedLabel=GPIO pins %s <br>on card %s"]
        x.graphics.exprs=[string(Pin),string(num_arduino)]
    end
endfunction
