//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//

function block=ARDUINO_ENCODER_sim(block,flag)
    global port_com arduino_sample_time handle;
    function DEBUG(message)
        disp("[DEBUG time = "+string(scicos_time())+"] {"+block.label+"} ARDUINO_ANALOG_READ Simulation: "+message);
    endfunction
    select flag
    case -5 // Error

    case 0 // Derivative State Update

    case 1 // Output Update
        // Envoi de la trame sur le port série pour dire de renvoyer la valeur comptée
        code_sent="Er"
        write_serial(handle,code_sent,2);

        //binary transfer
        valRead=read_serial(handle,4);
        val=int16(hex2dec(valRead));
//        disp(double(val))
        block.outptr(1)=evstr(double(val)); 

    case 2 // State Update

    case 3 // OutputEventTiming
        evout = block.evout(1);
        if evout < 0
            evout = arduino_sample_time;
        else
            evout = evout + arduino_sample_time;
        end
        block.evout(1) = evout;

case 4 // Initialization
        disp("Init Encoder");
        //          code_sent="Fa"+string(block.rpar(1))+string(block.rpar(4))+string(block.rpar(5))+string(block.rpar(3))
        code_sent="Ea"+asciimat(48+block.rpar(1))+asciimat(48+block.rpar(2))
//        disp(code_sent)
        //          writeserial(port_com,code_sent);
        write_serial(handle,code_sent,4)

case 5 // Endinglosing Encoder");
        disp("Closing Encoder")
        code_sent="Ed"+asciimat(48+block.rpar(1))+asciimat(48+block.rpar(2))
//        disp(code_sent)
        //          writeserial(port_com,code_sent);
        write_serial(handle,code_sent,4)       
        disp(code_sent)
    case 6 // Re-Initialisation

    case 9 // ZeroCrossing

    else // Unknown flag

    end
endfunction
