//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//

function [x, y, typ]=ARDUINO_INTERRUPT(job, arg1, arg2)
    x=[];
    y=[];
    typ=[];
    select job
    case 'plot' then
        // deprecated
    case 'getinputs' then
        // deprecated
    case 'getoutputs' then
        // deprecated
    case 'getorigin' then
        // deprecated
    case 'set' then
        disp('ARDUINO_INTERRUPT set')
        x=arg1;
        graphics=arg1.graphics;
        exprs=graphics.exprs
        disp(exprs)
        model=arg1.model;

        while %t do
            disp('while loop')
           [ok,num_pin,edge,upDown,num_arduino,exprs1]=scicos_getvalue(['Arduino Interrupt parameters'],..
            [gettext('Pin number');
             gettext('Edge 0:change, 1: falling, 2: rising');
             gettext('up-down: 0: up, 1:down');
             gettext('Arduino board number')],list('vec',1,'vec',1,'vec',1,'vec',1), exprs)
            mess=[];
            disp('ARDUINO_INT: after scicos_getvalue')
            disp(exprs)
            disp(size(exprs'))
            if ~ok then
                // Cancel
                break;
            end

            if num_arduino<>1 then
                mess=[mess ;gettext("Only card 1 can be used with this toolbox version ")];
                ok=%f;
            end

            if ok then
                // Everything's ok
                disp('ARDUINO_INTERRUPT ok')
                model.rpar=[num_pin,edge,upDown,num_arduino];
                graphics.exprs = exprs;
                x.model=model;
                x.graphics = graphics;
                break
            else
                message(mess);
            end
        disp('ARDUINO_INTERRUPT end set')
    end
    
    case 'define' then
//        disp('ARDUINO_INTTERUPT define')
        model=scicos_model();
        model.sim=list("ARDUINO_INTERRUPT_sim", 5)
        model.blocktype='d';
        model.dep_ut=[%f %f];
        model.out=[1];
        model.evtin=[1];
        model.evtout=[1];
        model.firing=[0;-1]
        Pin=15; num_arduino=1;
        edge=1;upDown=0;
        model.rpar=[Pin,edge,upDown,num_arduino]; //Default Pin number and Arduino card number
        x=standard_define([2 2],model,[],[]);
        x.graphics.out_implicit=['E'];
        x.graphics.style=["blockWithLabel;verticalLabelPosition=bottom;verticalAlign=top;displayedLabel=Pin %s<br>edge: %s updown %s on Arduino card %s"]
        x.graphics.exprs=[string(Pin),string(edge),string(upDown),string(num_arduino)];
    end
endfunction
