//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//

function block=ARDUINO_INTERRUPT_sim(block,flag)
    global port_com arduino_sample_time handle;
//    disp('ARDUINO_INTERRUPT_sim')
    function DEBUG(message)
        disp("[DEBUG time = "+string(scicos_time())+"] {"+block.label+"} ARDUINO_INTERRUPT Simulation: "+message);
    endfunction
    select flag
    case -5 // Error

    case 0 // Derivative State Update

    case 1 // Output Update
        // Envoi de la trame sur le port série pour dire de renvoyer la valeur comptée
        code_sent="Ir"+ascii(48+block.rpar(1));
        write_serial(handle,code_sent,3)

        //binary transfert
        valRead=read_serial(handle,4);
        val=hex2dec(valRead);
        block.outptr(1)=evstr(val);

    case 2 // State Update

    case 3 // OutputEventTiming
        evout = block.evout(1);
        if evout < 0
            evout = arduino_sample_time;
        else
            evout = evout + arduino_sample_time;
        end
        block.evout(1) = evout;
    case 4 // Initialization
        disp('Interrupt initialization')
        select block.rpar(2)
        case 0 then
            edge='c'
        case 1 then 
            edge='f'
        case 2 then
            edge='r'
        end
        select block.rpar(3)
        case 0 then
            upDown='u'
        case 1 then
            upDown='d'
        case 0 then
            upDown='c'
        end
//        disp('edge ')
//        disp(edge)
//        disp('upDown')
//        disp(upDown)       
        code_sent="Ia"+edge+upDown+ascii(48+block.rpar(1)); //on envoie plus le PIN mais le numéro d'interruption
        disp(code_sent)
        write_serial(handle,code_sent,5)
    case 5 // Ending
        code_sent="Id"+ascii(48+block.rpar(1));
        write_serial(handle,code_sent,3)
    case 6 // Re-Initialisation

    case 9 // ZeroCrossing

    else // Unknown flag

    end
endfunction
