//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//
global handle
function block=ARDUINO_SERVO_WRITE_sim(block,flag)
    global port_com arduino_sample_time handle
    function DEBUG(message)
        disp("[DEBUG time = "+string(scicos_time())+"] {"+block.label+"} ARDUINO_SERVO_WRITE Simulation: "+message);
    endfunction
    select flag
    case -5 // Error

    case 0 // Derivative State Update


    case 1 // Output Update
        u1 = block.inptr(1); 
        disp("Servo Write")

        if u1 < 10 then
            u1=10;           //code_sent="4"+ascii(97+block.rpar(1))+ascii(255);
        end;
        if u1 > 180 then
            u1 = 180;
        end;

        serial_code=msprintf("Ow%c%04d",ascii(48+block.rpar(1)),abs(u1));
        disp(serial_code);
            //code_sent="4"+ascii(97+block.rpar(1))+ascii(abs(ceil(u1)));    
//            code_sent=msprintf("P%c%02x",ascii(48+block.rpar(1)),ul);
//        end
        //        writeserial(port_com,code_sent);
        write_serial(handle,serial_code,7);

    case 2 // State Update

    case 3 // OutputEventTiming
        evout = block.evout(1);
        if evout < 0
            evout = arduino_sample_time;
        else
            evout = evout + arduino_sample_time;
        end
        block.evout(1) = evout;
    case 4 // Initialization
        serial_code=msprintf("Oa%c",ascii(48+block.rpar(1)));
        write_serial(handle,serial_code,3);
        //"You do not need to call pinMode() to set the pin as an output before calling analogWrite(). " 
    case 5 // Ending
        serial_code=msprintf("Od%c",ascii(48+block.rpar(1)));
        write_serial(handle,serial_code,3);

    case 6 // Re-Initialisation

    case 9 // ZeroCrossing

    else // Unknown flag

    end
endfunction
