//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//

function [x, y, typ]=ARDUINO_SETUP(job, arg1, arg2)
    x=[];
    y=[];
    typ=[];
    style = "ARDUINO_SETUP;blockWithLabel;"+..
            "verticalLabelPosition=bottom;verticalAlign=top;align=center;spacing=-3;"+..
            "displayedLabel=Board %s<br>on port %s"
    select job
    case 'plot' then
        // deprecated
    case 'getinputs' then
        // deprecated
    case 'getoutputs' then
        // deprecated
    case 'getorigin' then
        // deprecated
    case 'set' then
        x=arg1;
        graphics=arg1.graphics;
        exprs=graphics.exprs
        model=arg1.model;
        disp("Arduino Setup");
        while %t do
            [ok,num_arduino,port_com,exprs]=scicos_getvalue('Arduino Setup parameters',..
            [gettext('Identifier of Arduino card'),gettext('Serial port number')],                                                        list('vec',1,'vec',1), ..
            exprs)
            mess=[];

            if ~ok then// Cancel
                break;
            end

            if num_arduino >3 then
                mess=[gettext("Only 3 cards can be used with this toolbox version ")];
                ok=%f;
            end

            if port_com>3 | port_com<0 then
                mess=[gettext("Port must not be greater than 3. Change in the pannel configuration / Port  ")];
                ok=%f;
            end 
//            mystyle="displayedLabel=Board %s<br>on port %s";
            if ok then// Everything's ok
                model.rpar=[num_arduino,port_com];
                graphics.exprs = exprs;
                x.model=model;
                x.graphics = graphics;
 //               crap=msprintf(mystyle, expr);
 //               disp(crap)
                x.graphics.style = msprintf(style,exprs);
                break
            else
                message(mess);
            end

        end
    case 'define' then
        model=scicos_model();
        model.sim=list("ARDUINO_SETUP", 99)
        model.blocktype='c';
        model.dep_ut=[%f %f];
        model.in=[];
        num_arduino=1;
        port_com=0;
        model.rpar=[num_arduino,port_com]; //Digital Output number
        x=standard_define([2 2],model,[],[]);
        x.graphics.in_implicit=[];
        x.graphics.style= msprintf(style, string(num_arduino), string(port_com))
        x.graphics.exprs=[string(num_arduino),string(port_com)];
    end
endfunction
