//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//

function block=ARDUINO_SEVEN_SEG_DISPLAY_sim(block,flag)
    global port_com arduino_sample_time handle
//    disp("ARDUINO_DIG_WRITE")
    function DEBUG(message)
        disp("[DEBUG time = "+string(scicos_time())+"] {"+block.label+"} ARDUINO_SEVEN_SEG Simulation: "+message);
    endfunction
    select flag
    case -5 // Error

    case 0 // Derivative State Update


    case 1 // Output Update
        u1 = block.inptr(1);
	if block.rpar(1) == 0 then

        // here for hex format

//        disp("Seven Segment Write") 
            if u1 < 0 then
            u1 = 0;
        end;
        if u1 > hex2dec('ffff') then
            u1 = hex2dec('ffff');
        end;


        cmd = msprintf("7h%04x",u1);
//        disp(cmd);
            write_serial(handle,cmd,6);
	else
    
      // here for float forma	   
        if u1 < -999 then
            u1=-999
        end
        if u1 > 9999 then
            u1=9999
        end;
        cmd = msprintf("7f%.4f",u1);
        cmd = part(cmd,1:7);
        disp(cmd)
        write_serial(handle,cmd,7);
	end;
	
    case 2 // State Update

    case 3 // OutputEventTiming
        evout = block.evout(1);
        if evout < 0
            evout = arduino_sample_time;
        else
            evout = evout + arduino_sample_time;
        end
        block.evout(1) = evout;

    case 4 // Initialization
        disp("open seven segment display ")
        cmd="7o";
        write_serial(handle,cmd,2);


    case 5 // Ending
        disp("close seven segment display ")
        cmd="7c";
        write_serial(handle,cmd,2);



    case 6 // Re-Initialisation

    case 9 // ZeroCrossing

    else // Unknown flag

    end
endfunction
