//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//

function block=ARDUINO_STEPPER_sim(block,flag)
    global port_com arduino_sample_time handle oldValue
    function DEBUG(message)
        disp("[DEBUG time = "+string(scicos_time())+"] {"+block.label+"} ARDUINO_ANALOG_WRITE Simulation: "+message);
    endfunction
    select flag
    case -5 // Error

    case 0 // Derivative State Update

case 1 // Output Update
        u1 = block.inptr(1);
//        disp("stepper output update")
        if (oldValue ~= 0) & (oldValue ~= 1) then 
            oldValue=0
        end
//        disp(u1)   
        if (u1<0.1) then
            oldValue=0;
        else
            if oldValue == 0
                write_serial(handle,"Sm",2);
                oldValue=1;
            end
        end

    case 2 // State Update

case 3 // OutputEventTiming
//        disp("stepper output event timing")
        evout = block.evout(1);
        if evout < 0
            evout = arduino_sample_time;
        else
            evout = evout + arduino_sample_time;
        end
        block.evout(1) = evout;
        
     case 4 // Initialization
        disp("Init stepping motor");
        for i=1:4
            pin=block.rpar(i);
            word='Sa'+asciimat(48+pin)+asciimat(48+i);
            write_serial(handle,word,4);
//            disp(word)
        end
   
case 5 // Ending
         disp("Reset all pulse signals");
         word='Sc';
         write_serial(handle,word,2);

    case 6 // Re-Initialisation

    case 9 // ZeroCrossing

    else // Unknown flag

    end
endfunction
